import traceback

from pymilvus import connections,utility,FieldSchema,CollectionSchema,DataType,Collection


def init_milvus(host):
    connections.connect("default",host=host,port=19530)


def drop_embedding_collection(collection_name):
    print("drop collection:",collection_name)
    utility.drop_collection(collection_name)


def create_embedding_schema(collection_name,fields,index_name,index_params):
    has = utility.has_collection(collection_name)
    if not has:
        print("creating collection")
        coll_schema = CollectionSchema(fields,"this is the embedding schema")
        coll = Collection(collection_name,coll_schema,consistency_level="Strong")

        #create index for milvus_embedding
        coll.create_index(index_name,index_params=index_params)

def getCollection(collection_name):
    coll = Collection(collection_name)
    print(collection_name,"num_entities",coll.num_entities)
    return coll


def insert_embedding(coll,entities):
    coll.insert(entities)
    coll.load()
    print("num_entities",coll.num_entities)


def search_embedding(coll,index_name,vector,search_params,output_fields,limit=3):
    list_result = []
    result = coll.search(vector,index_name,search_params,output_fields=output_fields,limit=limit)
    for hits in result:
        for hit in hits:
            list_result.append(hit)
    return list_result

if __name__ == '__main__':
    # drop_embedding_collection()
    create_embedding_schema()

