
from BaseDataMaintenance.model.ots.BaseModel import BaseModel

DOCUMENT_PRODUCT_DICT_ID = "id"
DOCUMENT_PRODUCT_DICT_NAME = "name"
DOCUMENT_PRODUCT_DICT_ALIAS = "alias"
DOCUMENT_PRODUCT_DICT_GRADE = "grade"
DOCUMENT_PRODUCT_DICT_STATUS = "status"
DOCUMENT_PRODUCT_DICT_PARENT_ID = "parent_id"
DOCUMENT_PRODUCT_DICT_CREATE_TIME = "create_time"
DOCUMENT_PRODUCT_DICT_UPDATE_TIME = "update_time"
DOCUMENT_PRODUCT_DICT_IS_SYNCHONIZED = "is_synchonized"

DOCUMENT_PRODUCT_DICT_STANDARD_ALIAS = "standard_alias"

DOCUMENT_PRODUCT_DICT_STANDARD_ALIAS_SEPARATOR = "|"

MAX_NAME_LENGTH = 300

class Document_product_dict(BaseModel):

    def __init__(self,_dict):
        BaseModel.__init__(self)
        for k,v in _dict.items():
            self.setValue(k,v,True)
        self.table_name = "document_product_dict"

    def getPrimary_keys(self):
        return ["id"]



    def updateAlias(self,name):
        name = str(name).lower()
        alias = self.getProperties().get(DOCUMENT_PRODUCT_DICT_ALIAS,"")
        l_alias = alias.split("&&")
        if name not in set(l_alias):
            alias+="&&%s"%name
            self.setValue(DOCUMENT_PRODUCT_DICT_ALIAS,alias,True)
            return True
        return False


from BaseDataMaintenance.common.documentFingerprint import getMD5
def get_document_product_dict_id(parent_md5,name):
    return getMD5(parent_md5+"&&%s"%name)

def get_document_product_dict_standard_alias_id(name):
    return getMD5("alias&&%s"%name)